diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 8d90c292e..7508c0be3 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -1,7 +1,9 @@
 package net.minecraft.core.achievement.stat;
 
 import java.io.File;
+import java.util.Collections;
 import java.util.HashMap;
+import java.util.Locale;
 import java.util.Map;
 
 import com.b100.json.JsonParser;
@@ -13,17 +15,20 @@ import com.b100.utils.FileUtils;
 import net.minecraft.core.MD5String;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.player.Session;
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.collection.NamespaceID;
+import org.jetbrains.annotations.Unmodifiable;
 
 public class StatsCounter {
 
-	private final Map<Stat, Integer> statMap1;
-	private final Map<Stat, Integer> statMap2;
+	private final Map<Stat, Integer> sessionStats; // Local copy of stats used by the client
+	private final Map<Stat, Integer> savedStats;
 	private boolean modified;
 	private final StatsSyncher statsSyncher;
 
 	public StatsCounter(Session session, File mcDir) {
-		statMap1 = new HashMap<>();
-		statMap2 = new HashMap<>();
+		sessionStats = new HashMap<>();
+		savedStats = new HashMap<>();
 		modified = false;
 		
 		File statsFolder = new File(mcDir, "stats");
@@ -34,77 +39,139 @@ public class StatsCounter {
 		statsSyncher = new StatsSyncher(session, this, statsFolder);
 	}
 
-	public void addValueToStat(Stat stat, int value) {
-		addValueToStatMap(statMap2, stat, value);
-		addValueToStatMap(statMap1, stat, value);
+	public void add(Stat stat, int amount) {
+		addToMap(savedStats, stat, amount);
+		addToMap(sessionStats, stat, amount);
 		modified = true;
 	}
 
-	private void addValueToStatMap(Map<Stat, Integer> map, Stat stat, int value) {
-		Integer integer = map.get(stat);
-		int currentValue = integer != null ? integer : 0;
-
-		map.put(stat, currentValue + value);
+	private void addToMap(Map<Stat, Integer> map, Stat stat, int amount) {
+		int currentValue = map.getOrDefault(stat, 0);
+		map.put(stat, currentValue + amount);
 	}
 
-	public Map<Stat, Integer> cloneMap() {
-		return new HashMap<>(statMap2);
+	@Unmodifiable
+	public Map<Stat, Integer> getSavedStats() {
+		return Collections.unmodifiableMap(savedStats);
 	}
 
-	public void func_27179_a(Map<Stat, Integer> map) {
-		if(map == null) {
+	public void addToBoth(Map<Stat, Integer> changes) {
+		if(changes == null) {
 			return;
 		}
 		modified = true;
-		for (Stat stat : map.keySet()) {
-			addValueToStatMap(statMap2, stat, map.get(stat));
-			addValueToStatMap(statMap1, stat, map.get(stat));
+		for (Stat stat : changes.keySet()) {
+			addToMap(savedStats, stat, changes.get(stat));
+			addToMap(sessionStats, stat, changes.get(stat));
 		}
 
 	}
 
-	public void func_27180_b(Map<Stat, Integer> map) {
-		if(map == null) {
+	public void addToLocal(Map<Stat, Integer> changes) {
+		if(changes == null) {
 			return;
 		}
-		for (Stat stat : map.keySet()) {
-			Integer integer = statMap2.get(stat);
-			int value = integer != null ? integer : 0;
-			statMap1.put(stat, map.get(stat) + value);
+		for (Stat stat : changes.keySet()) {
+			int currentValue = savedStats.getOrDefault(stat, 0);
+			sessionStats.put(stat, currentValue + changes.get(stat));
 		}
 
 	}
 
-	public void func_27187_c(Map<Stat, Integer> map) {
+	public void addToSaved(Map<Stat, Integer> map) {
 		if(map == null) {
 			return;
 		}
 		modified = true;
 		for (Stat stat : map.keySet()) {
-			addValueToStatMap(statMap2, stat, map.get(stat));
+			addToMap(savedStats, stat, map.get(stat));
+		}
+	}
+
+	public boolean isUnlocked(Achievement achievement) {
+		return sessionStats.containsKey(achievement);
+	}
+
+	public boolean canUnlock(Achievement achievement) {
+		return achievement.parent == null || isUnlocked(achievement.parent);
+	}
+
+	public int readStat(Stat stat) {
+		return sessionStats.getOrDefault(stat, 0);
+	}
+
+	public void fetchStats() {
+		// Another guess but my assumption is that this method was meant to be called by the game to fetch stats from the server
+		// while the player was paused or before the game saved stats to disk
+	}
+
+	public void saveStats() {
+		statsSyncher.saveStatsToDisk(getSavedStats());
+	}
+
+	public void tick() {
+		if(modified && statsSyncher.pendingSave()) {
+			statsSyncher.startSavingThread(getSavedStats());
+		}
+		statsSyncher.tick();
+	}
+
+	public void wipe(String stupidityCheck){
+		if (!stupidityCheck.toLowerCase(Locale.ROOT).equals("I want to delete all the saved stats".toLowerCase(Locale.ROOT))){
+			throw new RuntimeException("Did not properly confirm desire to delete saved stats");
 		}
+		sessionStats.clear();
+		savedStats.clear();
 	}
 
-	public static Map<Stat, Integer> func_27177_a(String s) {
+	public static void relocateStatFiles(File minecraftFolder, File statsFolder) {
+		//Move stat files from .minecraft to stats
+		File[] files = minecraftFolder.listFiles();
+        if (files != null){
+			for (File file : files) {
+				if (file.getName().startsWith("stats_") && file.getName().endsWith(".dat")) {
+					File destination = new File(statsFolder, file.getName());
+					if (!destination.exists()) {
+						System.out.println("Relocating " + file.getName());
+						file.renameTo(destination);
+					}
+				}
+			}
+		}
+	}
+
+	public static Map<Stat, Integer> readStatsFromString(String jsonString) {
 		Map<Stat, Integer> map = new HashMap<>();
 		try {
-			JsonParser jsonParser = new JsonParser();
-			JsonObject rootObject = jsonParser.parseString(s);
+			JsonParser parser = new JsonParser();
+			JsonObject rootObject = parser.parseString(jsonString);
 			JsonArray array = rootObject.getArray("stats-change");
-			
+
 			for(JsonElement element : array) {
 				JsonObject object = element.getAsObject();
 				JsonEntry entry = object.entryList().get(0);
-				
-				int i = Integer.parseInt(entry.name);
-				int j = entry.value.getAsNumber().getInteger();
-				
-				Stat stat = StatList.getStat(i);
+
+				String statId = entry.name;
+				int value = entry.value.getAsNumber().getInteger();
+
+				Stat stat;
+				try {
+					if (statId.contains(":")) {
+						stat = StatList.getStat(new NamespaceID(statId));
+					} else {
+						stat = StatList.StatConverter.getStatFromDeprecatedID(Integer.parseInt(statId));
+					}
+				} catch (HardIllegalArgumentException | NumberFormatException e){
+					e.printStackTrace();
+					continue;
+				}
+
+
 				if(stat == null) {
-					System.out.println(i + " is not a valid stat");
-				} else {
-					map.put(stat, j);
+					System.out.println(statId + " is not a valid stat");
+					continue;
 				}
+				map.put(stat, value);
 			}
 		} catch (Exception e) {
 			e.printStackTrace();
@@ -112,80 +179,39 @@ public class StatsCounter {
 		return map;
 	}
 
-	public static String getStatFileContentString(String username, String localString, Map<Stat, Integer> map) {
-		StringBuilder string1 = new StringBuilder();
-		StringBuilder string2 = new StringBuilder();
+	public static String getStatFileContentString(String username, String sessionID, Map<Stat, Integer> map) {
+		StringBuilder displayString = new StringBuilder();
+		StringBuilder checkSumString = new StringBuilder();
 		boolean flag = true;
-		string1.append("{\r\n");
-		if (username != null && localString != null) {
-			string1.append("  \"user\":{\r\n");
-			string1.append("    \"name\":\"").append(username).append("\",\r\n");
-			string1.append("    \"sessionid\":\"").append(localString).append("\"\r\n");
-			string1.append("  },\r\n");
+		displayString.append("{\r\n");
+		if (username != null && sessionID != null) {
+			displayString.append("  \"user\":{\r\n");
+			displayString.append("    \"name\":\"").append(username).append("\",\r\n");
+			displayString.append("    \"sessionid\":\"").append(sessionID).append("\"\r\n");
+			displayString.append("  },\r\n");
 		}
-		string1.append("  \"stats-change\":[");
+		displayString.append("  \"stats-change\":[");
 		Stat statbase;
 		for (Stat stat : map.keySet()) {
 			statbase = stat;
 			if (!flag) {
-				string1.append("},");
+				displayString.append("},");
 			} else {
 				flag = false;
 			}
-			string1.append("\r\n    {\"").append(statbase.statId).append("\":").append(map.get(statbase));
-			string2.append(statbase.statGuid).append(",");
-			string2.append(map.get(statbase)).append(",");
-		}
+			displayString.append("\r\n    {\"").append(statbase.statId).append("\":").append(map.get(statbase));
 
-		if (!flag) {
-			string1.append("}");
+			checkSumString.append(statbase.statId).append(","); // Used to use UUID rather than namespace
+			checkSumString.append(map.get(statbase)).append(",");
 		}
-		MD5String md5string = new MD5String(localString);
-		string1.append("\r\n  ],\r\n");
-		string1.append("  \"checksum\":\"").append(md5string.getString(string2.toString())).append("\"\r\n");
-		string1.append("}");
-		return string1.toString();
-	}
-
-	public boolean isAchievementUnlocked(Achievement achievement) {
-		return statMap1.containsKey(achievement);
-	}
 
-	public boolean isAchievementUnlockable(Achievement achievement) {
-		return achievement.parent == null || isAchievementUnlocked(achievement.parent);
-	}
-
-	public int readStat(Stat statbase) {
-		Integer integer = statMap1.get(statbase);
-		return integer != null ? integer : 0;
-	}
-
-	public void func_27175_b() {
-	}
-
-	public void syncStats() {
-		statsSyncher.syncStatsFileWithMap(cloneMap());
-	}
-
-	public void func_27178_d() {
-		if(modified && statsSyncher.func_27420_b()) {
-			statsSyncher.func_27424_a(cloneMap());
-		}
-		statsSyncher.func_27425_c();
-	}
-	
-	public static void relocateStatFiles(File minecraftFolder, File statsFolder) {
-		//Move stat files from .minecraft to stats
-		File[] files = minecraftFolder.listFiles();
-		for (int i = 0; i < files.length; i++) {
-			File file = files[i];
-			if(file.getName().startsWith("stats_") && file.getName().endsWith(".dat")) {
-				File file3 = new File(statsFolder, file.getName());
-				if(!file3.exists()) {
-					System.out.println("Relocating " + file.getName());
-					file.renameTo(file3);
-				}
-			}
+		if (!flag) {
+			displayString.append("}");
 		}
+		MD5String md5string = new MD5String(sessionID);
+		displayString.append("\r\n  ],\r\n");
+		displayString.append("  \"checksum\":\"").append(md5string.getString(checkSumString.toString())).append("\"\r\n");
+		displayString.append("}");
+		return displayString.toString();
 	}
 }
diff --git a/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java b/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
index f19a8322c..fe8535eb8 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/StatsSyncher.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.achievement.stat;
 
+import com.b100.utils.StringUtils;
 import net.minecraft.core.player.Session;
 
 import java.io.*;
@@ -8,8 +9,8 @@ import java.util.Map;
 public class StatsSyncher {
 
     private volatile boolean busy = false;
-    private volatile Map<Stat, Integer> map1;
-    private volatile Map<Stat, Integer> map2;
+    private volatile Map<Stat, Integer> queuedLocalStatsChanges;
+    private volatile Map<Stat, Integer> queuedSavedStatsChanges;
     private final StatsCounter statsCounter;
     private final File unsentStatsFile;
     private final File statsFile;
@@ -18,14 +19,14 @@ public class StatsSyncher {
     private final File unsentStatsFileOld;
     private final File statsFileOld;
     private final Session session;
-    private int int1;
-    private int int2;
+    private int saveTimer;
+    private int fetchChangesTimer; // Im making a sorta longshot guess but I think this is the remnant of an unused timer to retrieve stat changes from the server
 
     public StatsSyncher(Session session, StatsCounter statsCounter, File statsDir) {
-        map1 = null;
-        map2 = null;
-        int1 = 0;
-        int2 = 0;
+        queuedLocalStatsChanges = null;
+        queuedSavedStatsChanges = null;
+        saveTimer = 0;
+        fetchChangesTimer = 0;
         unsentStatsFile = new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.dat");
         statsFile = new File(statsDir, "stats_" + session.username.toLowerCase() + ".dat");
         unsentStatsFileOld = new File(statsDir, "stats_" + session.username.toLowerCase() + "_unsent.old");
@@ -43,9 +44,9 @@ public class StatsSyncher {
         this.statsCounter = statsCounter;
         this.session = session;
         if (unsentStatsFile.exists()) {
-            statsCounter.func_27179_a(readStatsFromFile(unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld));
+            statsCounter.addToBoth(readStatsFromFile(unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld));
         }
-        func_27418_a();
+        startRetrievalThread();
     }
 
     private void renameFile(File file, String s, File file1) {
@@ -70,25 +71,10 @@ public class StatsSyncher {
     }
 
     private Map<Stat, Integer> readStatsFromFile(File statsFile) {
-        BufferedReader reader = null;
         try {
-            reader = new BufferedReader(new FileReader(statsFile));
-            String line;
-            StringBuilder sb = new StringBuilder();
-            while ((line = reader.readLine()) != null) {
-                sb.append(line);
-            }
-            return StatsCounter.func_27177_a(sb.toString());
+            return StatsCounter.readStatsFromString(StringUtils.getFileContentAsString(statsFile));
         } catch (Exception e) {
             e.printStackTrace();
-        } finally {
-            if (reader != null) {
-                try {
-                    reader.close();
-                } catch (Exception e) {
-                    e.printStackTrace();
-                }
-            }
         }
         return null;
     }
@@ -107,18 +93,18 @@ public class StatsSyncher {
         tempStatsFile.renameTo(statsFile);
     }
 
-    public void func_27418_a() {
+    public void startRetrievalThread() {
         if (busy) {
             throw new IllegalStateException("Can't get stats from server while StatsSyncher is busy!");
         } else {
-            int1 = 100;
+            saveTimer = 100;
             busy = true;
             new Thread(() -> {
                 try {
-                    if (map1 != null) {
-                        saveStats(map1, statsFile, statsFileTemp, statsFileOld);
+                    if (queuedLocalStatsChanges != null) {
+                        saveStats(queuedLocalStatsChanges, statsFile, statsFileTemp, statsFileOld);
                     } else if (statsFile.exists()) {
-                        map1 = readStatsFromFile(statsFile, statsFileTemp, statsFileOld);
+                        queuedLocalStatsChanges = readStatsFromFile(statsFile, statsFileTemp, statsFileOld);
                     }
                 } catch (Exception exception) {
                     exception.printStackTrace();
@@ -129,15 +115,15 @@ public class StatsSyncher {
         }
     }
 
-    public void func_27424_a(Map<Stat, Integer> map) {
+    public void startSavingThread(Map<Stat, Integer> mapToSave) {
         if (busy) {
             throw new IllegalStateException("Can't save stats while StatsSyncher is busy!");
         } else {
-            int1 = 100;
+            saveTimer = 100;
             busy = true;
             new Thread(() -> {
                 try {
-                    saveStats(map, unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld);
+                    saveStats(mapToSave, unsentStatsFile, unsentStatsFileTemp, unsentStatsFileOld);
                 } catch (Exception exception) {
                     exception.printStackTrace();
                 } finally {
@@ -148,12 +134,12 @@ public class StatsSyncher {
         }
     }
 
-    public void syncStatsFileWithMap(Map<Stat, Integer> map) {
+    public void saveStatsToDisk(Map<Stat, Integer> map) {
         for (int i = 30; busy && --i > 0; ) {
             try {
                 Thread.sleep(100L);
-            } catch (InterruptedException interruptedexception) {
-                interruptedexception.printStackTrace();
+            } catch (InterruptedException interrupt) {
+                interrupt.printStackTrace();
             }
         }
 
@@ -167,24 +153,24 @@ public class StatsSyncher {
         }
     }
 
-    public boolean func_27420_b() {
-        return int1 <= 0 && !busy && map2 == null;
+    public boolean pendingSave() {
+        return saveTimer <= 0 && !busy && queuedSavedStatsChanges == null;
     }
 
-    public void func_27425_c() {
-        if (int1 > 0) {
-            int1--;
+    public void tick() {
+        if (saveTimer > 0) {
+            saveTimer--;
         }
-        if (int2 > 0) {
-            int2--;
+        if (fetchChangesTimer > 0) {
+            fetchChangesTimer--;
         }
-        if (map2 != null) {
-            statsCounter.func_27187_c(map2);
-            map2 = null;
+        if (queuedSavedStatsChanges != null) {
+            statsCounter.addToSaved(queuedSavedStatsChanges);
+            queuedSavedStatsChanges = null;
         }
-        if (map1 != null) {
-            statsCounter.func_27180_b(map1);
-            map1 = null;
+        if (queuedLocalStatsChanges != null) {
+            statsCounter.addToLocal(queuedLocalStatsChanges);
+            queuedLocalStatsChanges = null;
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/achievement/stat/TimeValueFormatter.java b/src/main/java/net/minecraft/core/achievement/stat/TimeValueFormatter.java
new file mode 100644
index 000000000..d6b8c0bb5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/achievement/stat/TimeValueFormatter.java
@@ -0,0 +1,38 @@
+package net.minecraft.core.achievement.stat;
+
+// Referenced classes of package net.minecraft.src:
+//            StatValueFormatter, StatBase
+
+import net.minecraft.core.Global;
+
+final class TimeValueFormatter implements StatValueFormatter {
+    public static double UNIT_SECONDS_TO_MINUTES = 1d/60;
+    public static double UNIT_MINUTES_TO_HOURS = 1d/60;
+    public static double UNIT_HOURS_TO_DAYS = 1d/24;
+    public static double UNIT_DAYS_TO_YEARS = 1d/365.2425;
+
+
+    @Override
+	public String formatValue(int value)
+    {
+        double seconds = (double) value / Global.TICKS_PER_SECOND;
+        double minutes = seconds * UNIT_SECONDS_TO_MINUTES;
+        double hours = minutes * UNIT_MINUTES_TO_HOURS;
+        double days = hours * UNIT_HOURS_TO_DAYS;
+        double years = days * UNIT_DAYS_TO_YEARS;
+        if(years > 0.5D) {
+            return Stat.getDecimalFormat().format(years) + " y";
+        }
+        if(days > 0.5D) {
+            return Stat.getDecimalFormat().format(days) + " d";
+        }
+        if(hours > 0.5D) {
+            return Stat.getDecimalFormat().format(hours) + " h";
+        }
+        if(minutes > 0.5D) {
+            return Stat.getDecimalFormat().format(minutes) + " m";
+        } else {
+            return seconds + " s";
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockAlgae.java b/src/main/java/net/minecraft/core/block/AlgaeBlock.java
similarity index 79%
rename from src/main/java/net/minecraft/core/block/BlockAlgae.java
rename to src/main/java/net/minecraft/core/block/AlgaeBlock.java
index 0cddb5cf9..c4eb4b712 100644
--- a/src/main/java/net/minecraft/core/block/BlockAlgae.java
+++ b/src/main/java/net/minecraft/core/block/AlgaeBlock.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.WorldSource;
@@ -13,22 +13,22 @@ import net.minecraft.core.util.phys.AABB;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB,
-//            IBlockAccess, Item, EntityItem, ItemStack,
-//            StatList, EntityPlayer, EnumSkyBlock
+//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            StatList, Player, EnumSkyBlock
 
-public class BlockAlgae extends Block
+public class AlgaeBlock extends Block
 {
 
-    protected BlockAlgae(String key, int id, Material material)
+    protected AlgaeBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setBlockBounds(0.0F, -0.125F, 0.0F, 1.0F, 0.00625f, 1.0F);
     }
 
     @Override
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
-        if(entity instanceof EntityBoat) {
+        if(entity instanceof BoatEntity) {
             int data = world.getBlockMetadata(x, y, z);
             world.playSoundEffect(null, 2001, x, y, z, id);
             world.setBlockWithNotify(x, y, z, 0);
@@ -64,13 +64,13 @@ public class BlockAlgae extends Block
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockAxisAligned.java b/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
similarity index 58%
rename from src/main/java/net/minecraft/core/block/BlockAxisAligned.java
rename to src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
index d62a736d8..d53abc802 100644
--- a/src/main/java/net/minecraft/core/block/BlockAxisAligned.java
+++ b/src/main/java/net/minecraft/core/block/AxisAlignedBlock.java
@@ -1,22 +1,21 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.World;
 
-public class BlockAxisAligned extends Block {
+public class AxisAlignedBlock extends Block {
 
-	public BlockAxisAligned(String key, int id, Material material) {
-		super(key, id, material);
+	public AxisAlignedBlock(String key, String namespaceId, int id, Material material) {
+		super(key, namespaceId, id, material);
 	}
 
 	@Override
-	public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-		Axis axis = entity.getPlacementDirection(side, PlacementMode.SIDE).getAxis();
+	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+		Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).getAxis();
 		
 		world.setBlockMetadataWithNotify(x, y, z, axisToMeta(axis));
 	}
diff --git a/src/main/java/net/minecraft/core/block/BlockLayerBase.java b/src/main/java/net/minecraft/core/block/BaseLayerBlock.java
similarity index 66%
rename from src/main/java/net/minecraft/core/block/BlockLayerBase.java
rename to src/main/java/net/minecraft/core/block/BaseLayerBlock.java
index 1cb3d1f4d..4a08a9568 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerBase.java
+++ b/src/main/java/net/minecraft/core/block/BaseLayerBlock.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.item.block.ItemBlockLayer;
+import net.minecraft.core.item.block.LayerBlockItem;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
@@ -9,25 +9,25 @@ import java.util.function.Supplier;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
-//            IBlockAccess, Item, EntityItem, ItemStack, 
-//            StatList, EntityPlayer, EnumSkyBlock
+//            IBlockAccess, Item, ItemEntity, ItemStack,
+//            StatList, Player, EnumSkyBlock
 
-public abstract class BlockLayerBase extends Block
+public abstract class BaseLayerBlock extends Block
 {
     private Supplier<Integer> idSupplier = null;
 	public int fullBlockID = -1;
 	
-	public BlockLayerBase(String key, int id, Material material)
+	public BaseLayerBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
-        setBlockItem(() -> new ItemBlockLayer(this));
+        setBlockItem(() -> new LayerBlockItem(this));
     }
     @Override
     public void initializeBlock() {
         fullBlockID = idSupplier.get();
     }
-    public BlockLayerBase setFullBlockID(Supplier<Integer> idSupplier)
+    public BaseLayerBlock setFullBlockID(Supplier<Integer> idSupplier)
     {
     	this.idSupplier = idSupplier;
     	return this;
@@ -37,7 +37,7 @@ public abstract class BlockLayerBase extends Block
     {
         int l = world.getBlockMetadata(x, y, z) & 7;
         float f = (float)(2 * (1 + l)) / 16F;
-        return AABB.getBoundingBoxFromPool((double) x + minX, (double) y + minY, (double) z + minZ, (double) x + maxX, (float) y + f, (double) z + maxZ);
+        return AABB.getTemporaryBB((double) x + minX, (double) y + minY, (double) z + minZ, (double) x + maxX, (float) y + f, (double) z + maxZ);
     }
 
     @Override
@@ -47,7 +47,7 @@ public abstract class BlockLayerBase extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
similarity index 86%
rename from src/main/java/net/minecraft/core/block/BlockLeavesBase.java
rename to src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
index 9d9f1df12..a01d7f5e9 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
+++ b/src/main/java/net/minecraft/core/block/BaseLeavesBlock.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.ItemBlockLeaves;
+import net.minecraft.core.item.block.LeavesBlockItem;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -15,14 +15,18 @@ import java.util.Random;
 // Referenced classes of package net.minecraft.src:
 //            Block, IBlockAccess, Material
 
-public abstract class BlockLeavesBase extends Block
+public abstract class BaseLeavesBlock extends Block
 {
+    public static final int MASK_DECAY_DATA = 0b0000_1111;
+    public static final int NUM_DECAY_BITS = 4;
+    public static final int DECAY_FLAG_BIT = 3;
+    public static final int PERMANENT_FLAG_BIT = 0;
 
-	public BlockLeavesBase(String key, int id, Material material)
+	public BaseLeavesBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         setTicking(true);
-        setBlockItem(() -> new ItemBlockLeaves(this));
+        setBlockItem(() -> new LeavesBlockItem(this));
     }
 
     @Override
@@ -32,7 +36,7 @@ public abstract class BlockLeavesBase extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
 
         Season season = world.getSeasonManager().getCurrentSeason();
@@ -41,7 +45,7 @@ public abstract class BlockLeavesBase extends Block
 
         int numDropped = 1;
 
-        if (world.rand.nextInt(MathHelper.floor_double(dropRate)) != 0) return null;
+        if (world.rand.nextInt(MathHelper.floor(dropRate)) != 0) return null;
         
         return new ItemStack[] { new ItemStack(getSapling(), numDropped) };
     }
@@ -66,7 +70,7 @@ public abstract class BlockLeavesBase extends Block
                     for(int dz = -radius; dz <= radius; dz++)
                     {
                         int blockId = world.getBlockId(x + dx, y + dy, z + dz);
-                        if(Block.blocksList[blockId] instanceof BlockLeavesBase)
+                        if(Block.blocksList[blockId] instanceof BaseLeavesBlock)
                         {
                             int meta = world.getBlockMetadata(x + dx, y + dy, z + dz);
                             if (!isPermanent(meta))
@@ -107,12 +111,12 @@ public abstract class BlockLeavesBase extends Block
                         for(int zOffset = -byte0; zOffset <= byte0; zOffset++)
                         {
                             int k3 = world.getBlockId(x + xOffset, y + yOffset, z + zOffset);
-                            if(Block.blocksList[k3] instanceof BlockLog)
+                            if(Block.blocksList[k3] instanceof LogBlock)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = 0;
                                 continue;
                             }
-                            if(Block.blocksList[k3] instanceof BlockLeavesBase)
+                            if(Block.blocksList[k3] instanceof BaseLeavesBlock)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = -2;
                             } else
@@ -187,27 +191,25 @@ public abstract class BlockLeavesBase extends Block
         world.setBlockWithNotify(i, j, k, 0);
     }
 
-    public static final int MASK_PERMANENT = 0b0000_0001;
     public static boolean isPermanent(int meta) {
-    	return (meta & MASK_PERMANENT) != 0;
+    	return (meta & (0b1 << PERMANENT_FLAG_BIT)) != 0;
     }
-    public static int setPermanent(int meta, boolean flag){
-        if (flag){
-            return meta | MASK_PERMANENT;
-        } else {
-            return meta & ~MASK_PERMANENT;
+    public static int setPermanent(int meta, boolean permanent) {
+        if(permanent) {
+            return meta | (0b1 << PERMANENT_FLAG_BIT);
+        }else {
+            return meta & ~(0b1 << PERMANENT_FLAG_BIT);
         }
     }
-    
     public static boolean isDecaying(int meta) {
-    	return (meta & 8) != 0;
+    	return (meta & (0b1 << DECAY_FLAG_BIT)) != 0;
     }
     
     public static int setDecaying(int meta, boolean decaying) {
     	if(decaying) {
-    		return meta | 8;
+    		return meta | (0b1 << DECAY_FLAG_BIT);
     	}else {
-    		return meta & ~8;
+    		return meta & ~(0b1 << DECAY_FLAG_BIT);
     	}
     }
     
